// bingo2 for PLB (C) 2024 Shimeji Sola
// Card generator, to generate card pattern from a 9-digit card ID

class CardGenerator {
  constructor() {
    this.patterns = {
      "A": ["AKRCT", "AKRHT", "AKRDT", "AKRIT", "AKSRD", "AKSRI", "AKSRE", "AKSRJ", "ALSRD", "ALSRI", "ALSRE", "ALSRJ", "AMPCT", "AMPRE", "AMPRJ", "AMPDT", "AMPSE", "AMPSJ", "ANPCS", "ANPHS", "ANPRD", "ANPCT", "ANPHT", "ANPRE", "ANQCS", "ANQHS", "ANQCT", "ANQHT", "ANQDT", "ANQSE", "AKWCO", "AKWCT", "AKWHT", "AKWME", "AKWDO", "AKWDT", "AKWIT", "AKWNE", "AKXCN", "AKXMD", "AKXRD", "AKXRI", "AKXCO", "AKXME", "AKXRE", "AKXRJ", "ALXCN", "ALXRD", "ALXRI", "ALXCO", "ALXRE", "ALXRJ", "ALXDO", "ALXNE", "AMUCO", "AMUCT", "AMURE", "AMURJ", "AMUDO", "AMUDT", "AMUSE", "AMUSJ", "ANUCS", "ANUHS", "ANUMD", "ANURD", "ANUCT", "ANUHT", "ANUME", "ANURE", "ANVCS", "ANVHS", "ANVMD", "ANVCT", "ANVHT", "ANVME", "ANVDT", "ANVSE", "APWCO", "APWHT", "APWME", "APWDO", "APWIT", "APWNE", "APXCN", "APXMD", "APXRI", "APXCO", "APXME", "APXRJ", "AQXCN", "AQXCO", "AQXDO", "AQXNE", "ARUCO", "ARUHT", "ARUDO", "ARUIT", "ASUMD", "ASURI", "ASUME", "ASURJ", "ASVMD", "ASVME"],
      "B": ["BKRAT", "BKRPE", "BKRPJ", "BKRDT", "BKRIT", "BKSPD", "BKSPI", "BKSPE", "BKSPJ", "BLSPD", "BLSPI", "BLSPE", "BLSPJ", "BMPAT", "BMPFT", "BMPDT", "BMPSE", "BMPSJ", "BNPAS", "BNPFS", "BNPAT", "BNPFT", "BNPDT", "BNPSE", "BNQAS", "BNQFS", "BNQPD", "BNQAT", "BNQFT", "BNQPE", "BKWAO", "BKWAT", "BKWPE", "BKWPJ", "BKWDO", "BKWDT", "BKWIT", "BKWNE", "BKXAN", "BKXPD", "BKXPI", "BKXAO", "BKXPE", "BKXPJ", "BKXDO", "BKXNE", "BLXAN", "BLXKD", "BLXPD", "BLXPI", "BLXAO", "BLXKE", "BLXPE", "BLXPJ", "BMUAO", "BMUAT", "BMUFT", "BMUKE", "BMUDO", "BMUDT", "BMUSE", "BMUSJ", "BNUAS", "BNUFS", "BNUKD", "BNUAT", "BNUFT", "BNUKE", "BNUDT", "BNUSE", "BNVAS", "BNVFS", "BNVKD", "BNVPD", "BNVAT", "BNVFT", "BNVKE", "BNVPE", "BPWAO", "BPWFT", "BPWDO", "BPWIT", "BPWNE", "BPXAN", "BPXAO", "BPXDO", "BPXNE", "BQXAN", "BQXKD", "BQXPI", "BQXAO", "BQXKE", "BQXPJ", "BRUAO", "BRUFT", "BRUKE", "BRUDO", "BRUIT", "BSUKD", "BSUKE", "BSVKD", "BSVPI", "BSVKE", "BSVPJ"],
      "C": ["CKRAT", "CKRPE", "CKRPJ", "CKRBT", "CKRQE", "CKRQJ", "CKSAQ", "CKSPB", "CKSPE", "CKSPJ", "CKSQE", "CKSQJ", "CLSAQ", "CLSFQ", "CLSPB", "CLSPE", "CLSPJ", "CMPAT", "CMPFT", "CMPBT", "CMPGT", "CNPAT", "CNPFT", "CNPBT", "CNPGT", "CNQPB", "CNQPG", "CNQAT", "CNQFT", "CNQPE", "CKWAO", "CKWAT", "CKWPE", "CKWPJ", "CKWBO", "CKWBT", "CKWQE", "CKWQJ", "CKXAQ", "CKXPB", "CKXAO", "CKXPE", "CKXPJ", "CKXBO", "CKXQE", "CKXQJ", "CLXAQ", "CLXFQ", "CLXKB", "CLXPB", "CLXAO", "CLXKE", "CLXPE", "CLXPJ", "CMUAO", "CMUAT", "CMUFT", "CMUKE", "CMUBO", "CMUBT", "CMUGT", "CMULE", "CNUAL", "CNUKB", "CNUAT", "CNUFT", "CNUKE", "CNUBT", "CNUGT", "CNULE", "CNVAL", "CNVKB", "CNVPB", "CNVPG", "CNVAT", "CNVFT", "CNVKE", "CNVPE", "CPWAO", "CPWFT", "CPWBO", "CPWGT", "CPXAO", "CPXBO", "CQXKB", "CQXPG", "CQXAO", "CQXKE", "CQXPJ", "CRUAO", "CRUFT", "CRUKE", "CRUBO", "CRUGT", "CRULE", "CSUAL", "CSUKB", "CSUKE", "CSULE", "CSVAL", "CSVKB", "CSVPG", "CSVKE", "CSVPJ"],
      "D": ["DKRAQ", "DKRPB", "DKRPC", "DKRPH", "DKRQC", "DKRQH", "DKSAR", "DKSPC", "DKSPH", "DKSBR", "DKSQC", "DKSQH", "DLSAQ", "DLSFQ", "DLSPB", "DLSAR", "DLSFR", "DLSPC", "DMPAR", "DMPFR", "DMPBR", "DMPGR", "DNPAR", "DNPFR", "DNPBR", "DNPGR", "DNQPB", "DNQPG", "DNQPC", "DNQPH", "DKWAQ", "DKWPB", "DKWAM", "DKWPC", "DKWPH", "DKWBM", "DKWQC", "DKWQH", "DKXAM", "DKXAR", "DKXPC", "DKXPH", "DKXBM", "DKXBR", "DKXQC", "DKXQH", "DLXAQ", "DLXFQ", "DLXKB", "DLXPB", "DLXAR", "DLXFR", "DLXKC", "DLXPC", "DMUAL", "DMUKB", "DMUAR", "DMUFR", "DMUKC", "DMUBR", "DMUGR", "DMULC", "DNUAM", "DNUAR", "DNUFR", "DNUKC", "DNUBM", "DNUBR", "DNUGR", "DNULC", "DNVAL", "DNVKB", "DNVPB", "DNVPG", "DNVAM", "DNVKC", "DNVPC", "DNVPH", "DPWAM", "DPWBM", "DPXAM", "DPXFR", "DPXBM", "DPXGR", "DQXKB", "DQXPG", "DQXKC", "DQXPH", "DRUAL", "DRUKB", "DRUKC", "DRULC", "DSUAM", "DSUFR", "DSUKC", "DSUBM", "DSUGR", "DSULC", "DSVAL", "DSVKB", "DSVPG", "DSVAM", "DSVKC", "DSVPH"],
      "F": ["FARCT", "FARHT", "FARDT", "FARIT", "FASRD", "FASRI", "FASRE", "FASRJ", "FBSRD", "FBSRI", "FBSRE", "FBSRJ", "FCPHT", "FCPRE", "FCPRJ", "FCPIT", "FCPSE", "FCPSJ", "FDPCS", "FDPHS", "FDPRI", "FDPCT", "FDPHT", "FDPRJ", "FDQCS", "FDQHS", "FDQCT", "FDQHT", "FDQIT", "FDQSJ", "FAWCO", "FAWCT", "FAWHT", "FAWME", "FAWDO", "FAWDT", "FAWIT", "FAWNE", "FAXCN", "FAXMD", "FAXRD", "FAXRI", "FAXCO", "FAXME", "FAXRE", "FAXRJ", "FBXMD", "FBXRD", "FBXRI", "FBXME", "FBXRE", "FBXRJ", "FBXDO", "FBXNE", "FCUHT", "FCUME", "FCURE", "FCURJ", "FCUIT", "FCUNE", "FCUSE", "FCUSJ", "FDUCN", "FDUCS", "FDUHS", "FDURI", "FDUCO", "FDUCT", "FDUHT", "FDURJ", "FDVCN", "FDVCS", "FDVHS", "FDVCO", "FDVCT", "FDVHT", "FDVIT", "FDVSJ", "FPWCO", "FPWCT", "FPWME", "FPWDO", "FPWDT", "FPWNE", "FPXCN", "FPXMD", "FPXRD", "FPXCO", "FPXME", "FPXRE", "FQXCN", "FQXCO", "FQXDO", "FQXNE", "FRUCO", "FRUCT", "FRUDO", "FRUDT", "FSUMD", "FSURD", "FSUME", "FSURE", "FSVMD", "FSVME"],
      "G": ["GARFT", "GARPE", "GARPJ", "GARDT", "GARIT", "GASPD", "GASPI", "GASPE", "GASPJ", "GBSPD", "GBSPI", "GBSPE", "GBSPJ", "GCPAT", "GCPFT", "GCPIT", "GCPSE", "GCPSJ", "GDPAS", "GDPFS", "GDPAT", "GDPFT", "GDPIT", "GDPSJ", "GDQAS", "GDQFS", "GDQPI", "GDQAT", "GDQFT", "GDQPJ", "GAWFT", "GAWKE", "GAWPE", "GAWPJ", "GAWDO", "GAWDT", "GAWIT", "GAWNE", "GAXKD", "GAXPD", "GAXPI", "GAXKE", "GAXPE", "GAXPJ", "GAXDO", "GAXNE", "GBXAN", "GBXKD", "GBXPD", "GBXPI", "GBXAO", "GBXKE", "GBXPE", "GBXPJ", "GCUAO", "GCUAT", "GCUFT", "GCUKE", "GCUIT", "GCUNE", "GCUSE", "GCUSJ", "GDUAN", "GDUAS", "GDUFS", "GDUAO", "GDUAT", "GDUFT", "GDUIT", "GDUSJ", "GDVAN", "GDVAS", "GDVFS", "GDVPI", "GDVAO", "GDVAT", "GDVFT", "GDVPJ", "GPWAO", "GPWAT", "GPWDO", "GPWDT", "GPWNE", "GPXAN", "GPXAO", "GPXDO", "GPXNE", "GQXAN", "GQXKD", "GQXPD", "GQXAO", "GQXKE", "GQXPE", "GRUAO", "GRUAT", "GRUKE", "GRUDO", "GRUDT", "GSUKD", "GSUKE", "GSVKD", "GSVPD", "GSVKE", "GSVPE"],
      "H": ["HARFT", "HARPE", "HARPJ", "HARGT", "HARQE", "HARQJ", "HASFQ", "HASPG", "HASPE", "HASPJ", "HASQE", "HASQJ", "HBSAQ", "HBSFQ", "HBSPG", "HBSPE", "HBSPJ", "HCPAT", "HCPFT", "HCPBT", "HCPGT", "HDPAT", "HDPFT", "HDPBT", "HDPGT", "HDQPB", "HDQPG", "HDQAT", "HDQFT", "HDQPJ", "HAWFT", "HAWKE", "HAWPE", "HAWPJ", "HAWGT", "HAWLE", "HAWQE", "HAWQJ", "HAXFQ", "HAXPG", "HAXKE", "HAXPE", "HAXPJ", "HAXLE", "HAXQE", "HAXQJ", "HBXAL", "HBXAQ", "HBXFQ", "HBXPG", "HBXAO", "HBXKE", "HBXPE", "HBXPJ", "HCUAO", "HCUAT", "HCUFT", "HCUKE", "HCUBO", "HCUBT", "HCUGT", "HCULE", "HDUAL", "HDUKB", "HDUAO", "HDUAT", "HDUFT", "HDUBO", "HDUBT", "HDUGT", "HDVAL", "HDVKB", "HDVPB", "HDVPG", "HDVAO", "HDVAT", "HDVFT", "HDVPJ", "HPWAO", "HPWAT", "HPWBO", "HPWBT", "HPXAO", "HPXBO", "HQXKB", "HQXPB", "HQXAO", "HQXKE", "HQXPE", "HRUAO", "HRUAT", "HRUKE", "HRUBO", "HRUBT", "HRULE", "HSUAL", "HSUKB", "HSUKE", "HSULE", "HSVAL", "HSVKB", "HSVPB", "HSVKE", "HSVPE"],
      "I": ["IARFQ", "IARPG", "IARPC", "IARPH", "IARQC", "IARQH", "IASFR", "IASPC", "IASPH", "IASGR", "IASQC", "IASQH", "IBSAQ", "IBSFQ", "IBSPG", "IBSAR", "IBSFR", "IBSPH", "ICPAR", "ICPFR", "ICPBR", "ICPGR", "IDPAR", "IDPFR", "IDPBR", "IDPGR", "IDQPB", "IDQPG", "IDQPC", "IDQPH", "IAWFQ", "IAWPG", "IAWKC", "IAWPC", "IAWPH", "IAWLC", "IAWQC", "IAWQH", "IAXFR", "IAXKC", "IAXPC", "IAXPH", "IAXGR", "IAXLC", "IAXQC", "IAXQH", "IBXAL", "IBXAQ", "IBXFQ", "IBXPG", "IBXAM", "IBXAR", "IBXFR", "IBXPH", "ICUAL", "ICUKB", "ICUAM", "ICUAR", "ICUFR", "ICUBM", "ICUBR", "ICUGR", "IDUAM", "IDUAR", "IDUFR", "IDUKC", "IDUBM", "IDUBR", "IDUGR", "IDULC", "IDVAL", "IDVKB", "IDVPB", "IDVPG", "IDVAM", "IDVKC", "IDVPC", "IDVPH", "IPWAM", "IPWBM", "IPXAM", "IPXAR", "IPXBM", "IPXBR", "IQXKB", "IQXPB", "IQXKC", "IQXPC", "IRUAL", "IRUKB", "IRUKC", "IRULC", "ISUAM", "ISUAR", "ISUKC", "ISUBM", "ISUBR", "ISULC", "ISVAL", "ISVKB", "ISVPB", "ISVAM", "ISVKC", "ISVPC"],
      "K": ["KAHRE", "KAHRJ", "KAHSE", "KAHSJ", "KAICS", "KAIHS", "KAICT", "KAIHT", "KBIHS", "KBIHT", "KCFHT", "KCFRE", "KCFRJ", "KCFIT", "KCFSE", "KCFSJ", "KDFCS", "KDFHS", "KDFRI", "KDFCT", "KDFHT", "KDFRJ", "KDGRI", "KDGRJ", "KDGIT", "KDGSJ", "KAWCO", "KAWCT", "KAWHT", "KAWME", "KAWDO", "KAWDT", "KAWIT", "KAWNE", "KAXCN", "KAXMD", "KAXRD", "KAXRI", "KAXCO", "KAXME", "KAXRE", "KAXRJ", "KBXMD", "KBXRD", "KBXRI", "KBXME", "KBXRE", "KBXRJ", "KBXDO", "KBXNE", "KCUHT", "KCUME", "KCURE", "KCURJ", "KCUIT", "KCUNE", "KCUSE", "KCUSJ", "KDUCN", "KDUCS", "KDUHS", "KDURI", "KDUCO", "KDUCT", "KDUHT", "KDURJ", "KDVCN", "KDVCS", "KDVHS", "KDVCO", "KDVCT", "KDVHT", "KDVIT", "KDVSJ", "KFWCO", "KFWCT", "KFWME", "KFWDO", "KFWDT", "KFWNE", "KFXCN", "KFXMD", "KFXRD", "KFXCO", "KFXME", "KFXRE", "KGXMD", "KGXRD", "KGXME", "KGXRE", "KGXDO", "KGXNE", "KHUME", "KHURE", "KHUNE", "KHUSE", "KIUCN", "KIUCS", "KIUCO", "KIUCT", "KIVCN", "KIVCS", "KIVCO", "KIVCT"],
      "L": ["LAHFT", "LAHPE", "LAHPJ", "LAHSE", "LAHSJ", "LAIFS", "LAIFT", "LBIAS", "LBIFS", "LBIAT", "LBIFT", "LCFPE", "LCFPJ", "LCFIT", "LCFSE", "LCFSJ", "LDFPI", "LDFPJ", "LDFIT", "LDFSJ", "LDGAS", "LDGFS", "LDGPI", "LDGAT", "LDGFT", "LDGPJ", "LAWFT", "LAWKE", "LAWPE", "LAWPJ", "LAWDO", "LAWDT", "LAWIT", "LAWNE", "LAXKD", "LAXPD", "LAXPI", "LAXKE", "LAXPE", "LAXPJ", "LAXDO", "LAXNE", "LBXAN", "LBXKD", "LBXPD", "LBXPI", "LBXAO", "LBXKE", "LBXPE", "LBXPJ", "LCUAO", "LCUAT", "LCUFT", "LCUKE", "LCUIT", "LCUNE", "LCUSE", "LCUSJ", "LDUAN", "LDUAS", "LDUFS", "LDUAO", "LDUAT", "LDUFT", "LDUIT", "LDUSJ", "LDVAN", "LDVAS", "LDVFS", "LDVPI", "LDVAO", "LDVAT", "LDVFT", "LDVPJ", "LFWKE", "LFWPE", "LFWDO", "LFWDT", "LFWNE", "LFXKD", "LFXPD", "LFXKE", "LFXPE", "LFXDO", "LFXNE", "LGXAN", "LGXKD", "LGXPD", "LGXAO", "LGXKE", "LGXPE", "LHUAO", "LHUAT", "LHUKE", "LHUNE", "LHUSE", "LIUAN", "LIUAS", "LIUAO", "LIUAT", "LIVAN", "LIVAS", "LIVAO", "LIVAT"],
      "M": ["MAHFT", "MAHPE", "MAHPJ", "MAHGT", "MAHQE", "MAHQJ", "MAIFQ", "MAIPG", "MAIFT", "MAIGT", "MBIAQ", "MBIFQ", "MBIPG", "MBIAT", "MBIFT", "MCFPE", "MCFPJ", "MCFQE", "MCFQJ", "MDFPJ", "MDFQJ", "MDGAQ", "MDGFQ", "MDGAT", "MDGFT", "MDGPJ", "MAWFT", "MAWKE", "MAWPE", "MAWPJ", "MAWGT", "MAWLE", "MAWQE", "MAWQJ", "MAXFQ", "MAXPG", "MAXKE", "MAXPE", "MAXPJ", "MAXLE", "MAXQE", "MAXQJ", "MBXAL", "MBXAQ", "MBXFQ", "MBXPG", "MBXAO", "MBXKE", "MBXPE", "MBXPJ", "MCUAO", "MCUAT", "MCUFT", "MCUKE", "MCUBO", "MCUBT", "MCUGT", "MCULE", "MDUAL", "MDUKB", "MDUAO", "MDUAT", "MDUFT", "MDUBO", "MDUBT", "MDUGT", "MDVAL", "MDVKB", "MDVPB", "MDVPG", "MDVAO", "MDVAT", "MDVFT", "MDVPJ", "MFWKE", "MFWPE", "MFWLE", "MFWQE", "MFXKE", "MFXPE", "MFXLE", "MFXQE", "MGXAL", "MGXAQ", "MGXAO", "MGXKE", "MGXPE", "MHUAO", "MHUAT", "MHUKE", "MHUBO", "MHUBT", "MHULE", "MIUAL", "MIUKB", "MIUAO", "MIUAT", "MIUBO", "MIUBT", "MIVAL", "MIVKB", "MIVPB", "MIVAO", "MIVAT"],
      "N": ["NAHFQ", "NAHPG", "NAHFR", "NAHGR", "NAIFR", "NAIPC", "NAIPH", "NAIGR", "NAIQC", "NAIQH", "NBIAQ", "NBIFQ", "NBIPG", "NBIAR", "NBIFR", "NBIPH", "NCFPH", "NCFQH", "NDFPC", "NDFPH", "NDFQC", "NDFQH", "NDGAQ", "NDGFQ", "NDGAR", "NDGFR", "NAWFQ", "NAWPG", "NAWKC", "NAWPC", "NAWPH", "NAWLC", "NAWQC", "NAWQH", "NAXFR", "NAXKC", "NAXPC", "NAXPH", "NAXGR", "NAXLC", "NAXQC", "NAXQH", "NBXAL", "NBXAQ", "NBXFQ", "NBXPG", "NBXAM", "NBXAR", "NBXFR", "NBXPH", "NCUAL", "NCUKB", "NCUAM", "NCUAR", "NCUFR", "NCUBM", "NCUBR", "NCUGR", "NDUAM", "NDUAR", "NDUFR", "NDUKC", "NDUBM", "NDUBR", "NDUGR", "NDULC", "NDVAL", "NDVKB", "NDVPB", "NDVPG", "NDVAM", "NDVKC", "NDVPC", "NDVPH", "NFWKC", "NFWPC", "NFWLC", "NFWQC", "NFXKC", "NFXPC", "NFXLC", "NFXQC", "NGXAL", "NGXAQ", "NGXAM", "NGXAR", "NHUAL", "NHUKB", "NHUAM", "NHUAR", "NHUBM", "NHUBR", "NIUAM", "NIUAR", "NIUKC", "NIUBM", "NIUBR", "NIULC", "NIVAL", "NIVKB", "NIVPB", "NIVAM", "NIVKC", "NIVPC"],
      "P": ["PAHME", "PAHRJ", "PAHNE", "PAHSJ", "PAICN", "PAIHS", "PAICO", "PAIHT", "PBIHS", "PBIHT", "PCFHT", "PCFME", "PCFRJ", "PCFIT", "PCFNE", "PCFSJ", "PDFCN", "PDFHS", "PDFRI", "PDFCO", "PDFHT", "PDFRJ", "PDGRI", "PDGRJ", "PDGIT", "PDGSJ", "PAMCO", "PAMCT", "PAMRE", "PAMRJ", "PAMDO", "PAMDT", "PAMSE", "PAMSJ", "PANCS", "PANHS", "PANMD", "PANRD", "PANCT", "PANHT", "PANME", "PANRE", "PBNHS", "PBNMD", "PBNRD", "PBNHT", "PBNME", "PBNRE", "PBNDT", "PBNSE", "PCKHT", "PCKME", "PCKRE", "PCKRJ", "PCKIT", "PCKNE", "PCKSE", "PCKSJ", "PDKCN", "PDKCS", "PDKHS", "PDKRI", "PDKCO", "PDKCT", "PDKHT", "PDKRJ", "PDLCN", "PDLCS", "PDLRI", "PDLCO", "PDLCT", "PDLRJ", "PDLIT", "PDLSJ", "PFMCO", "PFMCT", "PFMRE", "PFMDO", "PFMDT", "PFMSE", "PFNCS", "PFNMD", "PFNRD", "PFNCT", "PFNME", "PFNRE", "PGNMD", "PGNRD", "PGNME", "PGNRE", "PGNDT", "PGNSE", "PHKME", "PHKRE", "PHKNE", "PHKSE", "PIKCN", "PIKCS", "PIKCO", "PIKCT", "PILCN", "PILCS", "PILCO", "PILCT"],
      "Q": ["QAHFT", "QAHKE", "QAHPJ", "QAHNE", "QAHSJ", "QAIFS", "QAIFT", "QBIAN", "QBIFS", "QBIAO", "QBIFT", "QCFKE", "QCFPJ", "QCFIT", "QCFNE", "QCFSJ", "QDFPI", "QDFPJ", "QDFIT", "QDFSJ", "QDGAN", "QDGFS", "QDGPI", "QDGAO", "QDGFT", "QDGPJ", "QAMFT", "QAMKE", "QAMPE", "QAMPJ", "QAMDO", "QAMDT", "QAMSE", "QAMSJ", "QANFS", "QANKD", "QANPD", "QANFT", "QANKE", "QANPE", "QANDT", "QANSE", "QBNAS", "QBNFS", "QBNKD", "QBNPD", "QBNAT", "QBNFT", "QBNKE", "QBNPE", "QCKAO", "QCKAT", "QCKPE", "QCKPJ", "QCKIT", "QCKNE", "QCKSE", "QCKSJ", "QDKAN", "QDKAS", "QDKPI", "QDKAO", "QDKAT", "QDKPJ", "QDKIT", "QDKSJ", "QDLAN", "QDLAS", "QDLFS", "QDLPI", "QDLAO", "QDLAT", "QDLFT", "QDLPJ", "QFMKE", "QFMPE", "QFMDO", "QFMDT", "QFMSE", "QFNKD", "QFNPD", "QFNKE", "QFNPE", "QFNDT", "QFNSE", "QGNAS", "QGNKD", "QGNPD", "QGNAT", "QGNKE", "QGNPE", "QHKAO", "QHKAT", "QHKPE", "QHKNE", "QHKSE", "QIKAN", "QIKAS", "QIKAO", "QIKAT", "QILAN", "QILAS", "QILAO", "QILAT"],
      "R": ["RAHFT", "RAHKE", "RAHPJ", "RAHGT", "RAHLE", "RAHQJ", "RAIFQ", "RAIPG", "RAIFT", "RAIGT", "RBIAL", "RBIFQ", "RBIPG", "RBIAO", "RBIFT", "RCFKE", "RCFPJ", "RCFLE", "RCFQJ", "RDFPJ", "RDFQJ", "RDGAL", "RDGFQ", "RDGAO", "RDGFT", "RDGPJ", "RAMFT", "RAMKE", "RAMPE", "RAMPJ", "RAMGT", "RAMLE", "RAMQE", "RAMQJ", "RANFQ", "RANPG", "RANFT", "RANKE", "RANPE", "RANGT", "RANLE", "RANQE", "RBNAL", "RBNAQ", "RBNFQ", "RBNPG", "RBNAT", "RBNFT", "RBNKE", "RBNPE", "RCKAO", "RCKAT", "RCKPE", "RCKPJ", "RCKBO", "RCKBT", "RCKQE", "RCKQJ", "RDKAQ", "RDKPB", "RDKAO", "RDKAT", "RDKPJ", "RDKBO", "RDKBT", "RDKQJ", "RDLAQ", "RDLFQ", "RDLKB", "RDLPB", "RDLAO", "RDLAT", "RDLFT", "RDLPJ", "RFMKE", "RFMPE", "RFMLE", "RFMQE", "RFNKE", "RFNPE", "RFNLE", "RFNQE", "RGNAL", "RGNAQ", "RGNAT", "RGNKE", "RGNPE", "RHKAO", "RHKAT", "RHKPE", "RHKBO", "RHKBT", "RHKQE", "RIKAQ", "RIKPB", "RIKAO", "RIKAT", "RIKBO", "RIKBT", "RILAQ", "RILKB", "RILPB", "RILAO", "RILAT"],
      "S": ["SAHFQ", "SAHPG", "SAHFR", "SAHGR", "SAIFR", "SAIKC", "SAIPH", "SAIGR", "SAILC", "SAIQH", "SBIAL", "SBIFQ", "SBIPG", "SBIAM", "SBIFR", "SBIPH", "SCFPH", "SCFQH", "SDFKC", "SDFPH", "SDFLC", "SDFQH", "SDGAL", "SDGFQ", "SDGAM", "SDGFR", "SAMFQ", "SAMPG", "SAMFR", "SAMKC", "SAMPC", "SAMGR", "SAMLC", "SAMQC", "SANFR", "SANKC", "SANPC", "SANPH", "SANGR", "SANLC", "SANQC", "SANQH", "SBNAL", "SBNAQ", "SBNFQ", "SBNPG", "SBNAM", "SBNAR", "SBNFR", "SBNPH", "SCKAQ", "SCKPB", "SCKAM", "SCKAR", "SCKPH", "SCKBM", "SCKBR", "SCKQH", "SDKAM", "SDKAR", "SDKPC", "SDKPH", "SDKBM", "SDKBR", "SDKQC", "SDKQH", "SDLAQ", "SDLFQ", "SDLKB", "SDLPB", "SDLAR", "SDLFR", "SDLKC", "SDLPC", "SFMKC", "SFMPC", "SFMLC", "SFMQC", "SFNKC", "SFNPC", "SFNLC", "SFNQC", "SGNAL", "SGNAQ", "SGNAM", "SGNAR", "SHKAQ", "SHKPB", "SHKAM", "SHKAR", "SHKBM", "SHKBR", "SIKAM", "SIKAR", "SIKPC", "SIKBM", "SIKBR", "SIKQC", "SILAQ", "SILKB", "SILPB", "SILAR", "SILKC", "SILPC"]
    };
    this.bigCells =  [[0, 1], [0, 5], [0, 6], [1, 1], [2, 1], [3, 5], [4, 5]];
    this.seed = new Uint32Array(1);
  }

  /**********************************/
  // decimal to base-26 encoder
  decToB26 (num) {
    let r = "";
    num = Math.max(0, Math.floor(num))
    do {
      r = String.fromCharCode(65 + num % 26) + r;
      num = Math.floor(num / 26);
    } while (num != 0);
    return r;
  }

  /**********************************/
  // base-26 to decimal decoder
  b26ToDec (str) {
    let r = 0;
    for (let i = 0; i < str.length; i++)
      r = r * 26 + str[i].charCodeAt() - 65;
    return r;
  }

  /**********************************/
  // XORShift random number generator
  xorShift32 () {
    this.seed[0];
    this.seed[0] = this.seed[0] ^ (this.seed[0] << 13);
    this.seed[0] = this.seed[0] ^ (this.seed[0] >>> 17);
    this.seed[0] = this.seed[0] ^ (this.seed[0] << 5);
  }

  /**********************************/
  // generate a random cell number for the selected column
  getNumber (selected, col, span) {
    let st = env.numPerColumn * col + 1;
    let ed = st + (env.numPerColumn * span) - 1;
    let candidates = [];  // far from elegant, but Firefox does not support iterator.map...
    for (let i = st; i <= ed; i++)
      if (! selected.includes(i))
        candidates.push(i);
    return candidates[this.seed[0] % candidates.length];
  }

  /**********************************/
  // generate card pattern from card ID
  generate (cardID) {
    if (cardID.length != 9 ||
        /[^A-Z]/.test(cardID) ||
        ! this.patterns.hasOwnProperty(cardID[0]) ||        // position of big cell
        this.b26ToDec(cardID[1]) >= env.numPerColumn * 2) { // number of big cell
      return null;
    }
    this.seed[0] = this.b26ToDec(cardID.slice(2, 9));

    let card = new Array(25).fill(0);
    let selected = new Array();
    this.xorShift32();
    let pat = this.patterns[cardID[0]][this.seed[0] % 104]; // look up position of special cells
    for (let i = 0; i < this.bigCells.length; i++) {
      let pos = this.b26ToDec(pat[this.bigCells[i][0]]);
      card[pos + this.bigCells[i][1]] = -this.bigCells[i][1];
      let num;
      if (card[pos] == 0) {
        if (this.bigCells[i][0] == 0) {
          num = this.b26ToDec(cardID[1]) + env.numPerColumn * (pos % 5) + 1;
          selected.push(Math.floor((num - 1) / 2) * 2 + 1);
          selected.push(Math.floor((num - 1) / 2) * 2 + 2);
        } else {
          this.xorShift32();
          num = this.getNumber(selected, pos % 5, (this.bigCells[i][1] == 1) ? 2 : 1);
          selected.push(num);
        }
        card[pos] = num;
      }
    }
    for (let i = 0; i < card.length; i++) {
      if (card[i] == 0) {
        this.xorShift32();
        card[i] = this.getNumber(selected, i % 5, 1);
        selected.push(card[i]);
      }
    }
    return card;
  }
}

gen = new CardGenerator();

/**********************************/